package com.hz.pm.api.projectlib.handle;

import com.hz.pm.api.projectlib.model.entity.Project;
import com.wflow.workflow.bean.vo.ProcessDetailVO;
import com.wflow.workflow.enums.StepStatusEnum;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * <p>
 * ApprovalAmountHandle
 * </p>
 *
 * @author WendyYang
 * @since 21:02 2024/4/8
 */
@Component
public class ApprovalAmountHandle extends AbstractProcessHandle {

    @Override
    void handle(HandleParamContext ctx) {
        Project project = ctx.getProject();
        List<ProcessDetailVO> processDetails = ctx.getProcessDetails();
        ProcessDetailVO detail = new ProcessDetailVO();
        processDetails.add(detail);
        detail.setProcessName(getProcessNode().getName());
        detail.setStepStatus(project.getApprovalAmount() != null ? StepStatusEnum.COMPLETED : StepStatusEnum.NOT_START);
    }

    @Override
    ProcessNode getProcessNode() {
        return ProcessNode.APPROVAL_AMOUNT;
    }

    @Override
    public int getOrder() {
        return getProcessNode().getOrder();
    }
}
